Subject: Re: Include coherency problem, sigaction and otherwise

From: "Kevin D. Kissell" <[email-masked]>
Date: Fri, 17 Mar 2000 19:28:38 +0100

William J. Earl writes:
>Kevin D. Kissell writes:
...
> > I have the impresson that the /usr/include stuff in the 
> > "Hard Hat" distribution for MIPS is keyed to a 2.0.x kernel, 
> > and that an update of /usr/include (as opposed to a downgrade 
> > of the kernel headers) may be in order.
...
>
>      As near as I can tell, at least for glibc-2.1.1-7, there
>is not machine-dependent <bits/sigaction.h> for mips, so the
>generic one is used, and the definitions are incompatible with the
>MIPS ABI.  The Linux kernel, on the other hand, is compatible with the
>MIPS ABI.  The cure is to supply a MIPS-specific <bits/sigaction.h>.

It's worse than that - the "Hard Hat" 5.1 distribution that serves
as the reference userland for most SGI/MIPS/Linux platforms
doesn't even have a /usr/include/bits directory, which seems
to have been a more recent invention.

            Regards,

            Kevin K.

---

From: Ralf Baechle <[email-masked]>
Date: Sat, 18 Mar 2000 01:08:01 -0300

> to have been a more recent invention.

The whole inconsistence was a stupid accident.  Since apparently only very
little software was affected negativly (read: no known problems) we didn't
try to come up with some genious compatibility hacks but just fixed the
definitions the hard way.  Current glibc snapshots and Linux kernels have
been fixed to use the same definitions.  If not, mail me a brown paperbag.

The bits/ subdirectory was introduced for glibc 2.1.

  Ralf

---

From: "William J. Earl" <[email-masked]>
Date: Fri, 17 Mar 2000 20:41:24 -0800 (PST)

Ralf Baechle writes:
...
 > The bits/ subdirectory was introduced for glibc 2.1.

    The bits/ subdirectory is present in 2.1, but at least 2.1.1-7 does
not have a bits/sigaction.h for MIPS in the source, so the generic 
one is used, and that is inconsistent with the kernel.  Which source
for glibc has a MIPS bits/sigaction.h?

---

From: Ralf Baechle <[email-masked]>
Date: Sat, 18 Mar 2000 01:59:43 -0300

On Fri, Mar 17, 2000 at 08:41:24PM -0800, William J. Earl wrote:

> one is used, and that is inconsistent with the kernel.

2.1 isn't supposed to be usable or even compilable for MIPS thanks to the
infamous linker problems.  Details on request.

> Which source for glibc has a MIPS bits/sigaction.h?

The latest Cygnus CVS development version has this and many other buglets
corrected mostly thanks to Andreas Jaeger who did start integrating my
old 2.0 port with the GNU sources and fix a ton of such buglets.

  Ralf